% Seja a planta discreta
Phi    = [0.7 -0.3 ; 0.1 0.5];
Gamma  = eye(2);
C      = eye(2);
D      = zeros(2,2);

Lambda = eye(2);
W = [0.1 0; 0 0.2];
V = [1.0 0; 0 2.0];

T      = 0.1;
S  = ss(Phi,Gamma,C,D,T);
Sx = ss(Phi,Gamma,eye(2),D,T);

% Filtro de Kalman
% Sistema aumentado para projetar o filtro (Veja '>> doc kalman' no Matlab)
H = zeros(2,2);
Saug = ss(Phi,[Gamma Lambda],C,[D H],T); 

[KF,L,P]=kalman(Saug,W,V); 

% Simulao
xo = [5 5];

sim('ex_kf_sim');


% Grficos
figure(1);
subplot(211)
h1 = stairs(tsim,ysim(:,1));
ColOrder = get(gca,'ColorOrder');
set(h1,'Marker','o','linewidth',2,'Color',ColOrder(1,:))
hold on
h2 = stairs(tsim,xsim(:,1));
set(h2,'Marker','o','linewidth',2,'Color',ColOrder(2,:))
h3 = stairs(tsim,xkf(:,1));
set(h3,'Marker','o','linewidth',2,'Color',ColOrder(3,:))
h4 = stairs(tsim,xsim_clean(:,1));
set(h4,'Marker','o','linewidth',1,'Color',ColOrder(4,:))
hold off
grid on
axis([0 5 -3 6])
xlabel('t (s)');
ylabel('(componente 1)')
title('Sistema em malha aberta com estado estimado por um filtro de Kalman')
legend([h1 h2 h3 h4],'sada medida','estado efetivo (no medido)','estado estimado','estado sem rudo')

subplot(212)
h1 = stairs(tsim,ysim(:,2));
ColOrder = get(gca,'ColorOrder');
set(h1,'Marker','o','linewidth',2,'Color',ColOrder(1,:))
hold on
h2 = stairs(tsim,xsim(:,2));
set(h2,'Marker','o','linewidth',2,'Color',ColOrder(2,:))
h3 = stairs(tsim,xkf(:,2));
set(h3,'Marker','o','linewidth',2,'Color',ColOrder(3,:))
h4 = stairs(tsim,xsim_clean(:,2));
set(h4,'Marker','o','linewidth',1,'Color',ColOrder(4,:))
hold off
grid on
axis([0 5 -3 6])
xlabel('t (s)');
ylabel('(componente 2)')
legend([h1 h2 h3 h4],'sada medida','estado efetivo (no medido)','estado estimado','estado sem rudo')

figure(2);
subplot(211)
h1 = plot(tsim,ysim(:,1));
ColOrder = get(gca,'ColorOrder');
set(h1,'linewidth',2,'Color',ColOrder(1,:))
hold on
h2 = plot(tsim,xsim(:,1));
set(h2,'linewidth',2,'Color',ColOrder(2,:))
h3 = plot(tsim,xkf(:,1));
set(h3,'linewidth',2,'Color',ColOrder(3,:))
h4 = plot(tsim,xsim_clean(:,1));
set(h4,'linewidth',1,'Color',ColOrder(4,:))
hold off
grid on
axis([0 5 -3 6])
xlabel('t (s)');
ylabel('(componente 1)')
title('Sistema em malha aberta com estado estimado por um filtro de Kalman')
legend([h1 h2 h3 h4],'sada medida','estado efetivo (no medido)','estado estimado','estado sem rudo')

subplot(212)
h1 = plot(tsim,ysim(:,2));
ColOrder = get(gca,'ColorOrder');
set(h1,'linewidth',2,'Color',ColOrder(1,:))
hold on
h2 = plot(tsim,xsim(:,2));
set(h2,'linewidth',2,'Color',ColOrder(2,:))
h3 = plot(tsim,xkf(:,2));
set(h3,'linewidth',2,'Color',ColOrder(3,:))
h4 = plot(tsim,xsim_clean(:,2));
set(h4,'linewidth',1,'Color',ColOrder(4,:))
hold off
grid on
axis([0 5 -3 6])
xlabel('t (s)');
ylabel('(componente 2)')
legend([h1 h2 h3 h4],'sada medida','estado efetivo (no medido)','estado estimado','estado sem rudo')

