% Realimentao de estado com pr-filtro

% Seja a planta
G  = zpk([],[0,-1],1);
S  = ss(G);
C  = [1 0];
I2 = eye(2);

% Discretizao
T = 0.1;
Sd = c2d(S,0.1,'zoh');

Phi   = Sd.a;
Gamma = Sd.b;

% Polos desejados
qsi = 0.45;
wn  = 2;
so  = roots([1 2*qsi*wn wn^2]);
zo  = exp(so*T);

% Controle
K = place(Phi,Gamma,zo)

% Pr-filtro
F = inv( C*inv(I2-Phi+Gamma*K)*Gamma )

% Sistema em malha fechada
Sdmf = ss((Phi-Gamma*K),Gamma,eye(2),0,T);

% Grfico
[y,t,x]=step(Sdmf);
y = F*y(:,1);

figure(1)
stairs(t,y,'-o')
grid
xlabel('t (s)')
ylabel('y(t)')
title('Resposta ao degrau da malha fechada (com pr-filtro)')